#include "./UpdateStatus.h"
#include <FastLED.h>
#include "../Static.h"

void
UpdateStatus::handleEvent(const InputEvent& evt)
{
    if (evt.intent == InputEvent::FirmwareUpdate) {
        static int updateCount = 0;
        updateCount++;
        Log.info("Update count %d", updateCount);
        m_updateReady = true;
    }
}

void
UpdateStatus::loop()
{
    m_pos++;
}

void
UpdateStatus::render(Display* dpy) const
{
    int pos = m_pos % dpy->pixelCount();
    if (m_updateReady) {
        for(int i = 0; i < 12; i+=3) {
            dpy->pixelAt(pos + i) = CRGB(255, 0, 0);
            dpy->pixelAt(pos + i + 1) = CRGB(0, 255, 0);
            dpy->pixelAt(pos + i + 2) = CRGB(0, 0, 255);
        }
    }
}

STATIC_ALLOC(UpdateStatus);
STATIC_TASK(UpdateStatus);
