#include <ArduinoOTA.h>
#include <Figments.h>

class ArduinoOTAUpdater : public BufferedInputSource {
  public:
    ArduinoOTAUpdater();
    void loop() override;
    void handleEvent(const InputEvent& evt) override;

  private:
    bool m_online = false;
    bool m_updating = false;
    static void s_onStart();
    static void s_onProgress(unsigned int progress, unsigned int total);
    static void s_onError(ota_error_t err);
    static void s_onFinished();
};
